propellor-5.10.1: property-based host configuration management in haskell

Safe Haskell | Safe
Language | Haskell98

Propellor.Types.ZFS

Description

Types for ZFS Properties.

Copyright 2016 Evan Cofsky evan@theunixman.com License: BSD 2-clause

Synopsis

- data ZFS = ZFS ZPool ZDataset
- data ZPool = ZPool String
- data ZDataset = ZDataset [String]
- type ZFSProperties = Set ZFSProperty
- fromList :: [ZFSProperty] -> ZFSProperties
- toPropertyList :: ZFSProperties -> [(String, String)]
- fromPropertyList :: [(String, String)] -> ZFSProperties
- zfsName :: ZFS -> String
- class Value a where
  - toValue :: a -> String
  - fromValue :: IsString a => String -> a
- data ZFSYesNo = ZFSYesNo Bool
- data ZFSOnOff = ZFSOnOff Bool
- data ZFSSize = ZFSSize Integer
- data ZFSString = ZFSString String
- data ZFSACLInherit
  - = AIDiscard
  - | AINoAllow
  - | AISecure
  - | AIPassthrough
- data ZFSACLMode
  - = AMDiscard
  - | AMGroupmask
  - | AMPassthrough
- data ZFSProperty
  - = Mounted ZFSYesNo
  - | Mountpoint ZFSString
  - | ReadOnly ZFSYesNo
  - | ACLInherit ZFSACLInherit
  - | ACLMode ZFSACLMode
  - | StringProperty String ZFSString
- toPair :: ZFSProperty -> (String, String)
- fromPair :: (String, String) -> ZFSProperty

# Documentation

data ZFS Source #

A single ZFS filesystem.

Constructors

ZFS ZPool ZDataset |

Instances

Eq ZFS Source # |
Instance details Defined in Propellor.Types.ZFS Methods (==) :: ZFS -> ZFS -> Bool (/=) :: ZFS -> ZFS -> Bool
Ord ZFS Source # |
Instance details Defined in Propellor.Types.ZFS Methods compare :: ZFS -> ZFS -> Ordering (<) :: ZFS -> ZFS -> Bool (<=) :: ZFS -> ZFS -> Bool (>) :: ZFS -> ZFS -> Bool (>=) :: ZFS -> ZFS -> Bool max :: ZFS -> ZFS -> ZFS min :: ZFS -> ZFS -> ZFS
Show ZFS Source # |
Instance details Defined in Propellor.Types.ZFS Methods showsPrec :: Int -> ZFS -> ShowS show :: ZFS -> String showList :: [ZFS] -> ShowS

data ZPool Source #

Represents a zpool.

Constructors

ZPool String |

Instances

Eq ZPool Source # |
Instance details Defined in Propellor.Types.ZFS Methods (==) :: ZPool -> ZPool -> Bool (/=) :: ZPool -> ZPool -> Bool
Ord ZPool Source # |
Instance details Defined in Propellor.Types.ZFS Methods compare :: ZPool -> ZPool -> Ordering (<) :: ZPool -> ZPool -> Bool (<=) :: ZPool -> ZPool -> Bool (>) :: ZPool -> ZPool -> Bool (>=) :: ZPool -> ZPool -> Bool max :: ZPool -> ZPool -> ZPool min :: ZPool -> ZPool -> ZPool
Show ZPool Source # |
Instance details Defined in Propellor.Types.ZFS Methods showsPrec :: Int -> ZPool -> ShowS show :: ZPool -> String showList :: [ZPool] -> ShowS
IsString ZPool Source # |
Instance details Defined in Propellor.Types.ZFS Methods fromString :: String -> ZPool #

data ZDataset Source #

Represents a dataset in a zpool.

Can be constructed from a / separated string.

Constructors

ZDataset [String] |

Instances

Eq ZDataset Source # |
Instance details Defined in Propellor.Types.ZFS Methods (==) :: ZDataset -> ZDataset -> Bool (/=) :: ZDataset -> ZDataset -> Bool
Ord ZDataset Source # |
Instance details Defined in Propellor.Types.ZFS Methods compare :: ZDataset -> ZDataset -> Ordering (<) :: ZDataset -> ZDataset -> Bool (<=) :: ZDataset -> ZDataset -> Bool (>) :: ZDataset -> ZDataset -> Bool (>=) :: ZDataset -> ZDataset -> Bool max :: ZDataset -> ZDataset -> ZDataset min :: ZDataset -> ZDataset -> ZDataset
Show ZDataset Source # |
Instance details Defined in Propellor.Types.ZFS Methods showsPrec :: Int -> ZDataset -> ShowS show :: ZDataset -> String showList :: [ZDataset] -> ShowS
IsString ZDataset Source # |
Instance details Defined in Propellor.Types.ZFS Methods fromString :: String -> ZDataset #
ConfigurableValue ZDataset Source # |
Instance details Defined in Propellor.Types.ZFS Methods val :: ZDataset -> String Source #

type ZFSProperties = Set ZFSProperty Source #

fromList :: [ZFSProperty] -> ZFSProperties Source #

toPropertyList :: ZFSProperties -> [(String, String)] Source #

fromPropertyList :: [(String, String)] -> ZFSProperties Source #

zfsName :: ZFS -> String Source #

class Value a where Source #

Minimal complete definition

toValue

Methods

toValue :: a -> String Source #

fromValue :: IsString a => String -> a Source #

Instances

Value ZFSACLMode Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSACLMode -> String Source # fromValue :: String -> ZFSACLMode Source #
Value ZFSACLInherit Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSACLInherit -> String Source # fromValue :: String -> ZFSACLInherit Source #
Value ZFSString Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSString -> String Source # fromValue :: String -> ZFSString Source #
Value ZFSSize Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSSize -> String Source # fromValue :: String -> ZFSSize Source #
Value ZFSOnOff Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSOnOff -> String Source # fromValue :: String -> ZFSOnOff Source #
Value ZFSYesNo Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSYesNo -> String Source # fromValue :: String -> ZFSYesNo Source #

data ZFSYesNo Source #

Constructors

ZFSYesNo Bool |

Instances

Eq ZFSYesNo Source # |
Instance details Defined in Propellor.Types.ZFS Methods (==) :: ZFSYesNo -> ZFSYesNo -> Bool (/=) :: ZFSYesNo -> ZFSYesNo -> Bool
Ord ZFSYesNo Source # |
Instance details Defined in Propellor.Types.ZFS Methods compare :: ZFSYesNo -> ZFSYesNo -> Ordering (<) :: ZFSYesNo -> ZFSYesNo -> Bool (<=) :: ZFSYesNo -> ZFSYesNo -> Bool (>) :: ZFSYesNo -> ZFSYesNo -> Bool (>=) :: ZFSYesNo -> ZFSYesNo -> Bool max :: ZFSYesNo -> ZFSYesNo -> ZFSYesNo min :: ZFSYesNo -> ZFSYesNo -> ZFSYesNo
Show ZFSYesNo Source # |
Instance details Defined in Propellor.Types.ZFS Methods showsPrec :: Int -> ZFSYesNo -> ShowS show :: ZFSYesNo -> String showList :: [ZFSYesNo] -> ShowS
IsString ZFSYesNo Source # |
Instance details Defined in Propellor.Types.ZFS Methods fromString :: String -> ZFSYesNo #
Value ZFSYesNo Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSYesNo -> String Source # fromValue :: String -> ZFSYesNo Source #

data ZFSOnOff Source #

Constructors

ZFSOnOff Bool |

Instances

Eq ZFSOnOff Source # |
Instance details Defined in Propellor.Types.ZFS Methods (==) :: ZFSOnOff -> ZFSOnOff -> Bool (/=) :: ZFSOnOff -> ZFSOnOff -> Bool
Ord ZFSOnOff Source # |
Instance details Defined in Propellor.Types.ZFS Methods compare :: ZFSOnOff -> ZFSOnOff -> Ordering (<) :: ZFSOnOff -> ZFSOnOff -> Bool (<=) :: ZFSOnOff -> ZFSOnOff -> Bool (>) :: ZFSOnOff -> ZFSOnOff -> Bool (>=) :: ZFSOnOff -> ZFSOnOff -> Bool max :: ZFSOnOff -> ZFSOnOff -> ZFSOnOff min :: ZFSOnOff -> ZFSOnOff -> ZFSOnOff
Show ZFSOnOff Source # |
Instance details Defined in Propellor.Types.ZFS Methods showsPrec :: Int -> ZFSOnOff -> ShowS show :: ZFSOnOff -> String showList :: [ZFSOnOff] -> ShowS
IsString ZFSOnOff Source # |
Instance details Defined in Propellor.Types.ZFS Methods fromString :: String -> ZFSOnOff #
Value ZFSOnOff Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSOnOff -> String Source # fromValue :: String -> ZFSOnOff Source #

data ZFSSize Source #

Constructors

ZFSSize Integer |

Instances

Eq ZFSSize Source # |
Instance details Defined in Propellor.Types.ZFS Methods (==) :: ZFSSize -> ZFSSize -> Bool (/=) :: ZFSSize -> ZFSSize -> Bool
Ord ZFSSize Source # |
Instance details Defined in Propellor.Types.ZFS Methods compare :: ZFSSize -> ZFSSize -> Ordering (<) :: ZFSSize -> ZFSSize -> Bool (<=) :: ZFSSize -> ZFSSize -> Bool (>) :: ZFSSize -> ZFSSize -> Bool (>=) :: ZFSSize -> ZFSSize -> Bool max :: ZFSSize -> ZFSSize -> ZFSSize min :: ZFSSize -> ZFSSize -> ZFSSize
Show ZFSSize Source # |
Instance details Defined in Propellor.Types.ZFS Methods showsPrec :: Int -> ZFSSize -> ShowS show :: ZFSSize -> String showList :: [ZFSSize] -> ShowS
Value ZFSSize Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSSize -> String Source # fromValue :: String -> ZFSSize Source #

data ZFSString Source #

Constructors

ZFSString String |

Instances

Eq ZFSString Source # |
Instance details Defined in Propellor.Types.ZFS Methods (==) :: ZFSString -> ZFSString -> Bool (/=) :: ZFSString -> ZFSString -> Bool
Ord ZFSString Source # |
Instance details Defined in Propellor.Types.ZFS Methods compare :: ZFSString -> ZFSString -> Ordering (<) :: ZFSString -> ZFSString -> Bool (<=) :: ZFSString -> ZFSString -> Bool (>) :: ZFSString -> ZFSString -> Bool (>=) :: ZFSString -> ZFSString -> Bool max :: ZFSString -> ZFSString -> ZFSString min :: ZFSString -> ZFSString -> ZFSString
Show ZFSString Source # |
Instance details Defined in Propellor.Types.ZFS Methods showsPrec :: Int -> ZFSString -> ShowS show :: ZFSString -> String showList :: [ZFSString] -> ShowS
IsString ZFSString Source # |
Instance details Defined in Propellor.Types.ZFS Methods fromString :: String -> ZFSString #
Value ZFSString Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSString -> String Source # fromValue :: String -> ZFSString Source #

data ZFSACLInherit Source #

Constructors

AIDiscard |
AINoAllow |
AISecure |
AIPassthrough |

Instances

Eq ZFSACLInherit Source # |
Instance details Defined in Propellor.Types.ZFS Methods (==) :: ZFSACLInherit -> ZFSACLInherit -> Bool (/=) :: ZFSACLInherit -> ZFSACLInherit -> Bool
Ord ZFSACLInherit Source # |

Instance details

Defined in Propellor.Types.ZFS

Methods

compare :: ZFSACLInherit -> ZFSACLInherit -> Ordering

(<) :: ZFSACLInherit -> ZFSACLInherit -> Bool

(<=) :: ZFSACLInherit -> ZFSACLInherit -> Bool

(>) :: ZFSACLInherit -> ZFSACLInherit -> Bool

(>=) :: ZFSACLInherit -> ZFSACLInherit -> Bool

max :: ZFSACLInherit -> ZFSACLInherit -> ZFSACLInherit

min :: ZFSACLInherit -> ZFSACLInherit -> ZFSACLInherit

Show ZFSACLInherit Source # |
Instance details Defined in Propellor.Types.ZFS Methods showsPrec :: Int -> ZFSACLInherit -> ShowS show :: ZFSACLInherit -> String showList :: [ZFSACLInherit] -> ShowS
IsString ZFSACLInherit Source # |
Instance details Defined in Propellor.Types.ZFS Methods fromString :: String -> ZFSACLInherit #
Value ZFSACLInherit Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSACLInherit -> String Source # fromValue :: String -> ZFSACLInherit Source #

data ZFSACLMode Source #

Constructors

AMDiscard |
AMGroupmask |
AMPassthrough |

Instances

Eq ZFSACLMode Source # |
Instance details Defined in Propellor.Types.ZFS Methods (==) :: ZFSACLMode -> ZFSACLMode -> Bool (/=) :: ZFSACLMode -> ZFSACLMode -> Bool
Ord ZFSACLMode Source # |
Instance details Defined in Propellor.Types.ZFS Methods compare :: ZFSACLMode -> ZFSACLMode -> Ordering (<) :: ZFSACLMode -> ZFSACLMode -> Bool (<=) :: ZFSACLMode -> ZFSACLMode -> Bool (>) :: ZFSACLMode -> ZFSACLMode -> Bool (>=) :: ZFSACLMode -> ZFSACLMode -> Bool max :: ZFSACLMode -> ZFSACLMode -> ZFSACLMode min :: ZFSACLMode -> ZFSACLMode -> ZFSACLMode
Show ZFSACLMode Source # |
Instance details Defined in Propellor.Types.ZFS Methods showsPrec :: Int -> ZFSACLMode -> ShowS show :: ZFSACLMode -> String showList :: [ZFSACLMode] -> ShowS
IsString ZFSACLMode Source # |
Instance details Defined in Propellor.Types.ZFS Methods fromString :: String -> ZFSACLMode #
Value ZFSACLMode Source # |
Instance details Defined in Propellor.Types.ZFS Methods toValue :: ZFSACLMode -> String Source # fromValue :: String -> ZFSACLMode Source #

data ZFSProperty Source #

Constructors

Mounted ZFSYesNo |
Mountpoint ZFSString |
ReadOnly ZFSYesNo |
ACLInherit ZFSACLInherit |
ACLMode ZFSACLMode |
StringProperty String ZFSString |

Instances

Eq ZFSProperty Source # |
Instance details Defined in Propellor.Types.ZFS Methods (==) :: ZFSProperty -> ZFSProperty -> Bool (/=) :: ZFSProperty -> ZFSProperty -> Bool
Ord ZFSProperty Source # |
Instance details Defined in Propellor.Types.ZFS Methods compare :: ZFSProperty -> ZFSProperty -> Ordering (<) :: ZFSProperty -> ZFSProperty -> Bool (<=) :: ZFSProperty -> ZFSProperty -> Bool (>) :: ZFSProperty -> ZFSProperty -> Bool (>=) :: ZFSProperty -> ZFSProperty -> Bool max :: ZFSProperty -> ZFSProperty -> ZFSProperty min :: ZFSProperty -> ZFSProperty -> ZFSProperty
Show ZFSProperty Source # |
Instance details Defined in Propellor.Types.ZFS Methods showsPrec :: Int -> ZFSProperty -> ShowS show :: ZFSProperty -> String showList :: [ZFSProperty] -> ShowS

toPair :: ZFSProperty -> (String, String) Source #

fromPair :: (String, String) -> ZFSProperty Source #